/**
 * generated by Xtext 2.12.0
 */
package com.minres.rdl.generator;

import com.minres.rdl.RdlUtil;
import com.minres.rdl.generator.AddrmapGenerator;
import com.minres.rdl.generator.FwAddrmapGenerator;
import com.minres.rdl.generator.FwRegfileGenerator;
import com.minres.rdl.generator.RdlBaseGenerator;
import com.minres.rdl.generator.RegfileGenerator;
import com.minres.rdl.rdl.ComponentDefinition;
import com.minres.rdl.rdl.ComponentDefinitionType;
import java.util.Collections;
import java.util.Map;
import java.util.function.BiConsumer;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.Pair;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class RDLGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    final Function1<Notifier, Boolean> _function = (Notifier it) -> {
      return Boolean.valueOf((it instanceof ComponentDefinition));
    };
    final Function1<Notifier, ComponentDefinition> _function_1 = (Notifier it) -> {
      return ((ComponentDefinition) it);
    };
    final Procedure1<ComponentDefinition> _function_2 = (ComponentDefinition it) -> {
      final Map<String, RdlBaseGenerator> genMap = this.fileGenerator(it);
      if ((genMap != null)) {
        final BiConsumer<String, RdlBaseGenerator> _function_3 = (String p1, RdlBaseGenerator gen) -> {
          final String header = gen.generateHeader();
          if (((header != null) && (header.length() > 0))) {
            String _effectiveName = RdlUtil.effectiveName(it);
            String _plus = ((p1 + "/") + _effectiveName);
            String _plus_1 = (_plus + ".h");
            fsa.generateFile(_plus_1, this.outputConfig(fsa, "incl-out"), header);
          }
          final String source = gen.generateSource();
          if (((source != null) && (source.length() > 0))) {
            String _effectiveName_1 = RdlUtil.effectiveName(it);
            String _plus_2 = ((p1 + "/") + _effectiveName_1);
            String _plus_3 = (_plus_2 + ".cpp");
            fsa.generateFile(_plus_3, this.outputConfig(fsa, "src-out"), source);
          }
        };
        genMap.forEach(_function_3);
      }
    };
    IteratorExtensions.<ComponentDefinition>forEach(IteratorExtensions.<Notifier, ComponentDefinition>map(IteratorExtensions.<Notifier>filter(resource.getResourceSet().getAllContents(), _function), _function_1), _function_2);
  }
  
  public Map<String, RdlBaseGenerator> fileGenerator(final ComponentDefinition definition) {
    Map<String, RdlBaseGenerator> _switchResult = null;
    ComponentDefinitionType _type = definition.getType();
    if (_type != null) {
      switch (_type) {
        case REGFILE:
          RegfileGenerator _regfileGenerator = new RegfileGenerator(definition);
          Pair<String, RegfileGenerator> _mappedTo = Pair.<String, RegfileGenerator>of("vp", _regfileGenerator);
          FwRegfileGenerator _fwRegfileGenerator = new FwRegfileGenerator(definition);
          Pair<String, FwRegfileGenerator> _mappedTo_1 = Pair.<String, FwRegfileGenerator>of("fw", _fwRegfileGenerator);
          _switchResult = Collections.<String, RdlBaseGenerator>unmodifiableMap(CollectionLiterals.<String, RdlBaseGenerator>newHashMap(_mappedTo, _mappedTo_1));
          break;
        case ADDRMAP:
          AddrmapGenerator _addrmapGenerator = new AddrmapGenerator(definition);
          Pair<String, AddrmapGenerator> _mappedTo_2 = Pair.<String, AddrmapGenerator>of("vp", _addrmapGenerator);
          FwAddrmapGenerator _fwAddrmapGenerator = new FwAddrmapGenerator(definition);
          Pair<String, FwAddrmapGenerator> _mappedTo_3 = Pair.<String, FwAddrmapGenerator>of("fw", _fwAddrmapGenerator);
          _switchResult = Collections.<String, RdlBaseGenerator>unmodifiableMap(CollectionLiterals.<String, RdlBaseGenerator>newHashMap(_mappedTo_2, _mappedTo_3));
          break;
        default:
          _switchResult = null;
          break;
      }
    } else {
      _switchResult = null;
    }
    return _switchResult;
  }
  
  public String outputConfig(final IFileSystemAccess2 fsa, final String string) {
    String output_config = string;
    try {
      fsa.getURI("", output_config);
    } catch (final Throwable _t) {
      if (_t instanceof Exception) {
        output_config = "DEFAULT_OUTPUT";
      } else {
        throw Exceptions.sneakyThrow(_t);
      }
    }
    return output_config;
  }
}
